#!/bin/sh -

#detecting and removing the Vodafone Application
if [ `killall -dc "Vodafone Mobile Broadband" | grep -ci pid` != 1 ]; then 
    echo "The Vodafone application has not been detected."
    exit 0

fi

#The Vodafone Appliction is running and the client has choose to remove it
echo "Kill all VMB Processes"

#nice_quit=nice_quit.py
#"$nice_quit" "Vodafone Mobile Broadband"
# This should not be neccessary, because VMC never was in the market place. Never the less...
#"$nice_quit" "Vodafone Mobile Connect"

killall -9 "Vodafone Mobile Broadband"
killall -9 "Vodafone Mobile Connect"

killall -TERM VMCStatusMenu



#
# This script needs to run as root
#

echo "Remove VMC 2.0"

# Stop all processes from VMC 2
killall "Vodafone Mobile Connect"
killall NovamediaDiskSupressor
killall "GT Network Tuning"
killall NMPCCardDaemonVMC
killall NMPPPMonitor
killall nmpppstatsd
killall ZTE_Supressor

# Stop and remove Startup items und LaunchDaemon stuff
rm -r "/System/Library/StartupItems/GT Network Tuning" # TODO: möglicherweise im home folder folder
rm -r "/System/Library/StartupItems/NMPCCardDaemonVMC"
rm -r "/System/Library/StartupItems/NMPPPMonitor"

path="/Library/LaunchAgents/cn.com.zte.usbswapper.plist"
launchctl unload "$path"; rm -r "$path"

path="/Library/LaunchAgents/de.novamedia.NovamediaDiskSupressor.plist"
launchctl unload "$path"; rm -r "$path"

rm -r "/Library/StartupItems/ZTE_Supressor" # ZTE_Supressor da drinn
rm -r "/Library/StartupItems/NovamediaDiskSupressorStarter" # NovamediaDiskSupresorStarter da drinn
# TODO: wird der überhaupt installiert?

# Remove application itself
rm -r "/Applications/Vodafone Mobile Connect/"

# Remove support files
rm -r "/Library/Application Support/nova media/VMC"
rm -r "/Library/Application Support/Vodafone"


# Remove drivers
function remove_kext () {
	full_path="$1"
	kextunload "$full_path"
	rm -r "$full_path"
}

remove_kext "/System/Library/Extensions/NMPCCard.kext"

remove_kext "/System/Library/Extensions/OptionMSD.kext"
remove_kext "/System/Library/Extensions/OptionGTEdge.kext"
remove_kext "/System/Library/Extensions/OptionMM.kext"
remove_kext "/System/Library/Extensions/OptionQC.kext"
remove_kext "/System/Library/Extensions/OptionGTEdge.kext"
remove_kext "/System/Library/Extensions/OptionGTEdge.kext"
remove_kext "/System/Library/Extensions/OptionGTEdge.kext"

remove_kext "/System/Library/Extensions/NovatelMerlin.kext"
remove_kext "/System/Library/Extensions/NovatelWirelessFilter.kext"
remove_kext "/System/Library/Extensions/NovatelWireless3G.kext"

remove_kext "/System/Library/Extensions/ZTEUSBCDCACMControl.kext"
remove_kext "/System/Library/Extensions/ZTEUSBCDCACMData.kext"

remove_kext "/System/Library/Extensions/HuaweiDataCardDriver.kext"
remove_kext "/System/Library/Extensions/USBExpressCardCantWake_Huawei.kext"


echo "Remove VMB 3.0"

# Remove drivers
function remove_kext () {
	full_path="$1"
	
	if [ -a "$full_path" ]; then
		kextunload "$full_path"
		rm -r "$full_path"
	fi
}


# Kill all services
path="/Library/LaunchAgents/de.novamedia.VodafoneDeviceObserver.plist"
launchctl unload "$path"; rm -r "$path"
path="/System/Library/LaunchDaemons/de.novamedia.nmnetmgrd.plist"
launchctl unload "$path"; rm -r "$path"



# Remove support files
# Consider removing
rm -r "/Library/Application Support/Vodafone"
rm -r "/Library/Application Support/nova media/VMC"
rm "/Library/Modem Scripts/NM Universal Modem"
rm "/usr/sbin/nmnetmgrd" # Find out whats with the _launchd suffix

# Remove Receipts
rm -r "/Library/Receipts/Huawei Data Card Driver Installer.pkg"
rm -r "/Library/Receipts/Novatel Wireless 3G Data Card Driver Installer.pkg"
rm -r "/Library/Receipts/Option USB Driver Installer.pkg"
rm -r "/Library/Receipts/USBExpressCard Cant Wake Huawei Driver Installer.pkg"
rm -r "/Library/Receipts/Vodafone Mobile Connect App.pkg"
rm -r "/Library/Receipts/Vodafone Mobile Connect Core.pkg"
rm -r "/Library/Receipts/ZTE Data Card Driver Installer.pkg"
rm -r "/Library/Receipts/Samsung Cell Phone Driver Installer.pkg"
rm -r "/Library/Receipts/Bypass Driver Installer.pkg"

# Remove Frameworks
rm -r "/Library/Frameworks/gsm_device_tools.framework"
rm -r "/Library/Frameworks/NMDeviceObserver.framework"
rm -r "/Library/Frameworks/NMGsmKit.framework"
rm -r "/Library/Frameworks/NMNetCore.framework"
rm -r "/Library/Frameworks/NMNetWorker.framework"
rm -r "/Library/Frameworks/NMRegistrationCore.framework"
rm -r "/Library/Frameworks/NMStatistics.framework"


# Remove USB Stick drivers
remove_kext "/System/Library/Extensions/HuaweiDataCardDriver.kext"
remove_kext "/System/Library/Extensions/USBExpressCardCantWake_Huawei.kext"

#====================================
# Novatel drivers
remove_kext "/System/Library/Extensions/NovatelWireless3G.kext"
remove_kext "/System/Library/Extensions/NovatelWirelessFilter.kext"

# Vodafone-Novatel drivers
remove_kext "/System/Library/Extensions/Vodafone.kext"
remove_kext "/System/Library/Extensions/VodafoneFilter.kext"

#Common novatel & novatel-vodafone kernel extension
remove_kext "/System/Library/Extensions/NovatelWirelessUSBCDCECMControl.kext"
remove_kext "/System/Library/Extensions/NovatelWirelessUSBCDCECMData.kext"
#====================================

#old option driver: 1.11.0
remove_kext "/System/Library/Extensions/OptionQC.kext"
#new option drivers v2.14, 3.18, 1.14
remove_kext "/System/Library/Extensions/Option72.kext"
remove_kext "/System/Library/Extensions/OptionHS.kext"
remove_kext "/System/Library/Extensions/OptionMSD.kext"

# Old ZTE driver files
remove_kext "/System/Library/Extensions/ZTEUSBCDCACMControl.kext"

# New ZTE driver files
remove_kext "/System/Library/Extensions/ZTEUSBCDCACMData.kext"
remove_kext "/System/Library/Extensions/ZTEUSBMassStorageFilter.kext"

# New ZTE NDis file
remove_kext "/System/Library/Extensions/cdc.kext"
remove_kext "/System/Library/Extensions/cdc_ecm_qmi.kext"
rm -r "/usr/local/lib/libqmi_api.dylib"

# this name is not used anymore, but try to remove it anyway
remove_kext "/System/Library/Extensions/ZTEUSBCDCACMData_106.kext"
remove_kext "/System/Library/Extensions/ZTEUSBMassStorageFilter_106.kext"

# Remove Phone Drivers
remove_kext "/System/Library/Extensions/NMSmartplugSCSIDevice.kext"
remove_kext "/System/Library/Extensions/NMLGEDriver.kext"
remove_kext "/System/Library/Extensions/NMHuaweiPhonesVTPCDC.kext"

# Remove 10.6 Phone Drivers
remove_kext "/System/Library/Extensions/NMSmartplugSCSIDevice_106.kext"
remove_kext "/System/Library/Extensions/NMLGEDriver_106.kext"
remove_kext "/System/Library/Extensions/NMHuaweiPhonesVTPCDC_106.kext"
remove_kext "/System/Library/Extensions/NMSamsungDriver_106.kext"

#--------------------------------------------------------------------
# Remove RIM Drivers
#    uses the RIM reference counting tool for 'releasing' the RIM kexts

RIM_Ref_Tool=$(dirname "$0")/../BBInstallReferenceCount



remainingRefsVSP=`"$RIM_Ref_Tool" "-unreferenceVSP"`
echo "remainingRefsVSP:$remainingRefsVSP"

if [[ $remainingRefsVSP == 0 ]]; then
	rm -r "/Library/Frameworks/RIM_VSP.framework"
fi


remainingRefsVSPDR=`"$RIM_Ref_Tool" "-unreferenceVSPDR"`
echo "remainingRefsVSPDR:$remainingRefsVSPDR"

if [[ $remainingRefsVSPDR == 0 ]]; then
	remove_kext "/System/Library/Extensions/RIMBBVSP.kext"
fi


remainingRefsDR=`"$RIM_Ref_Tool" "-unreferenceDR"`
echo "remainingRefsDR:$remainingRefsDR"

if [[ $remainingRefsDR == 0 ]]; then
	remove_kext "/System/Library/Extensions/RIMBBUSB.kext"
fi

#--------------------------------------------------------------------


# Remove novamedias Mass Storage Bypass Drivers
remove_kext "/System/Library/Extensions/IceraUSBMassStorageBypass.kext"


echo "Remove all kext and deamons"




rm -r "/Library/Receipts/Huawei Cell Phone Driver Installer.pkg"
rm -r "/Library/Receipts/Huawei Data Card Driver Installer.pkg"
rm -r "/Library/Receipts/LG Cell Phone Driver Installer.pkg"
rm -r "/Library/Receipts/Novatel Wireless 3G Data Card Driver Installer.pkg"
rm -r "/Library/Receipts/Vodafone Broadband Modem Driver Installer.pkg"
rm -r "/Library/Receipts/Option USB Driver Installer.pkg"
rm -r "/Library/Receipts/Smartplug Driver Installer.pkg"
rm -r "/Library/Receipts/USBExpressCard Cant Wake Huawei Driver Installer.pkg"
rm -r "/Library/Receipts/ZTE Data Card Driver Installer.pkg"
rm -r "/Library/Receipts/Samsung Cell Phone Driver Installer.pkg"
rm -r "/Library/Receipts/Bypass Driver Installer.pkg"

rm -r "/Library/Receipts/Vodafone Core.pkg"
rm -r "/Library/Receipts/Vodafone Mobile Broadband App.pkg"


echo "Remove VMC Application"

# Remove application itself
# This has to be last, because Vodafone Utilities contain the deinstaller itself.
# If we deinstall ourself earlier, we can't access the remaining deinstall scripts
rm -r "/Applications/Vodafone Mobile Broadband.app"
# This should not be neccessary, because VMC never was in the market place. Never the less...
rm -r "/Applications/Vodafone Mobile Connect.app"
rm -r "/Applications/Vodafone Utilities"

exit 0

